#include <WiFiClient.h>
#include <HTTPClient.h>
#include <ArduinoJson.h>

//https://community.openhab.org/t/example-on-how-to-access-data-of-a-sunny-boy-sma-solar-inverter/50963/19

const char* ssid = "xxxxxxx";
const char* password = "xxxxxxxx";
const char* url = "http://192.168.0.164/dyn/login.json";
unsigned long currentMillis;

#define RXD2 16
#define TXD2 17

void setup() 
{
  Serial.begin(115200);
  Serial.println(ESP.getFreeHeap());
  WiFi.begin(ssid, password);   //WiFi connection
  Serial2.begin(9600,SERIAL_8N1,RXD2,TXD2,true);
  vTaskDelay(1000 / portTICK_RATE_MS); 
  Serial2.print(char(254));Serial2.print(char(1));vTaskDelay(200 / portTICK_RATE_MS); 
  Serial2.print(char(254));Serial2.print(char(207));vTaskDelay(200 / portTICK_RATE_MS); 
  Serial2.print(char(254));Serial2.print(char(128));vTaskDelay(200 / portTICK_RATE_MS); 
  Serial2.print(char(254));Serial2.print(char(13));vTaskDelay(200 / portTICK_RATE_MS);
  Serial.println(F("Waiting for connection"));  
  while (WiFi.status() != WL_CONNECTED) {  Serial.print("."); vTaskDelay(5000 / portTICK_RATE_MS); }
  Serial.print(F("Connected: "));Serial.println(WL_CONNECTED);

}
 
void loop() {
  HTTPClient http;
 while(WiFi.status()== WL_CONNECTED){
 
     http.end();
    Serial.println(F("@Top of the loop:"));
    vTaskDelay(10000 / portTICK_RATE_MS);
    Serial.println(F("in the loop"));
   
    http.begin(url);
    http.addHeader("User-Agent", "Mozilla/5.0 (Windows NT 6.0; WOW64; rv:24.0) Gecko/20100101 Firefox/24.0");
    http.addHeader("Content-Type", "application/json");
    http.addHeader("Connection" , "Keep-Alive");
    http.addHeader("Keep-Alive","timeout=5");
    http.addHeader("Keep-Alive","max=100");
    http.addHeader("Accept", "application/json, text/plain, */*");
    http.addHeader("Accept-Charset", "UTF-8");
    
    int httpCode = http.POST("{\"pass\":\"Kortrijk1\",\"right\":\"usr\"}");vTaskDelay(100 / portTICK_RATE_MS);
    
    Serial.print(F("Return code: "));Serial.println(httpCode);
    if (httpCode != 200 ) { http.end(); break;}
    
    String payload = http.getString();
        
    StaticJsonDocument<96> doc;
    DeserializationError error = deserializeJson(doc, payload);

     if (error) {
      Serial.print(F("deserializeJson() failed: "));Serial.println(error.f_str());
      return;
    }

    String result_sid = doc["err"]; // "WtgOHaTtE7Ktgbjr"
    Serial.print(F("return code from payload:"));Serial.println(result_sid);
    if (!result_sid.compareTo("503")) {Serial.println(F("ERROR code"));
                                       http.end();if (error) {Serial.print(F("http end failed: "));Serial.println(error.c_str());break;}
                                       }
                                       
    String result_sidd = doc["result"]["sid"];
    Serial.print(F("Received SID: "));Serial.println(result_sidd); 
    Serial.print(F("lenght SID: "));Serial.println(result_sidd.length()); 

    String data = "http://192.168.0.164/dyn/getValues.json?sid=";
    Serial.print(F("Data url: "));Serial.println(data); 
    Serial.print(F("Lenght url: "));Serial.println(data.length());

    data.concat(result_sidd);
    Serial.print(F("Data newurl: "));Serial.println(data); 
    Serial.print(F("Lenght newurl: "));Serial.println(data.length());
   
    http.end();
    Serial.println("waiting...");
    vTaskDelay(1000 / portTICK_RATE_MS);
    http.begin(data);

    StaticJsonDocument<192> doc2;
    JsonArray destDev = doc2.createNestedArray("destDev");
    JsonArray keys = doc2.createNestedArray("keys");
    keys.add("6400_00260100");
    keys.add("6400_00262200");
    keys.add("6100_40263F00");
    String output;
    serializeJson(doc2, output);
    Serial.println(output);
    int httpCode2 = http.POST(output);//Serial.println(httpCode2); 
    String payload2 = http.getString();
    
    //Serial.println(payload2);
    
    Serial.println(F("just before http end"));
    http.end();// program sometimes crashes on this point, 
    if (error) {Serial.print(F("http end failed: "));Serial.println(error.c_str()); } else { Serial.print(F("http end done: "));Serial.println(error.c_str());}
    Serial.println(F("just after http end"));
    
    StaticJsonDocument<512> docc;

    DeserializationError errorr = deserializeJson(docc, payload2);

    if (errorr) {
      Serial.print(F("deserializeJson() failed: "));Serial.println(errorr.f_str()); return;} 

    JsonObject result_012F_730B7309 = docc["result"]["012F-730B7309"];

    long result_012F_730B7309_6400_00260100_1_0_val = result_012F_730B7309["6400_00260100"]["1"][0]["val"];
    Serial.print(F("Total Power: "));Serial.print(result_012F_730B7309_6400_00260100_1_0_val);Serial.println(" Watt");
    int result_012F_730B7309_6400_00262200_1_0_val = result_012F_730B7309["6400_00262200"]["1"][0]["val"];
    Serial.print(F("Total Power today: "));Serial.print(result_012F_730B7309_6400_00262200_1_0_val);Serial.println(" Watt");
    int result_012F_730B7309_6100_40263F00_1_0_val = result_012F_730B7309["6100_40263F00"]["1"][0]["val"];
    Serial.print(F("Power current: "));Serial.print(result_012F_730B7309_6100_40263F00_1_0_val);Serial.println(" Watt");
    //const char* result_012F_730B7309_6180_104AB900_1_0_val = result_012F_730B7309["6180_104AB900"]["1"][0]["val"];
    //currentMillis = millis();  while (millis() <= (currentMillis + 200)) {}
    Serial2.print(char(254));Serial2.print(char(1));vTaskDelay(200 / portTICK_RATE_MS);
    Serial2.print(char(254));Serial2.print(char(128));vTaskDelay(200 / portTICK_RATE_MS);
    Serial2.print(F("Tot: "));Serial2.print(result_012F_730B7309_6400_00260100_1_0_val);Serial2.print("W");currentMillis = millis();  while (millis() <= (currentMillis + 200)) {}
    Serial2.print(char(254));Serial2.print(char(192));vTaskDelay(200 / portTICK_RATE_MS);
    Serial2.print(F("Cur: "));Serial2.print(result_012F_730B7309_6100_40263F00_1_0_val);Serial2.print("W");currentMillis = millis();  while (millis() <= (currentMillis + 200)) {}
    Serial2.print(char(254));Serial2.print(char(207));vTaskDelay(200 / portTICK_RATE_MS);

    
}
}

//////// //(’{“destDev”:[],“keys”:[“6400_00260100”,“6400_00262200”]}’)  
////        ’{“destDev”:[],“keys”:[“6400_00260100”,“6400_00262200”]}’)
////        payload = ('{"destDev":[],"keys":["6400_00260100","6400_00262200","6100_40263F00","6180_104AB900"]}')
